//Thanks to Simon Lothar for this function
typedef char*(*sc_cpv)(void);
const unsigned int sc0135[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0135 };
#define Disp_GetVRAM (*(sc_cpv)sc0135)
char *Disp_VRAM;

void Disp_Init()
{
  Disp_VRAM = Disp_GetVRAM();
}

void Disp_Pixel(int x, int y, int v)
{
  if(x&~127 || y&~63) return;
  if(v) *(Disp_VRAM+(y<<4)+(x>>3)) |=  (128>>(x&7));
  else  *(Disp_VRAM+(y<<4)+(x>>3)) &= ~(128>>(x&7));
}

int Disp_Get(int x, int y)
{
  return (*(Disp_VRAM+(y<<4)+(x>>3)) >> (~x&7))&1;
}

void Disp_Clear()
{
  int i=0;
  for(i=0;i<1024;i++) *(Disp_VRAM+i)=0;
}

void Disp_Bitmap(const unsigned char *b, int x, int y, int w, int h, int m)
{
  unsigned char v;
  int i,j;

  for(i=0;i<h;i++) for(j=0;j<w;j++)
  {
    v = (*(b+i*(((w-1)>>3)+1)+(j>>3))>>(~j&7))&1;

    switch(m)
    {
      case 0: if(!v) Disp_Pixel(x+j,y+i,0); break;
      case 1: if(v)  Disp_Pixel(x+j,y+i,1); break;
      case 2: if(v)  Disp_Pixel(x+j,y+i,!Disp_Get(x+j,y+i)); break;
    }
  }
}
