/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/

#include "fxlib.h"
#include "clock.h"

void DrawTime(struct Temps *ptemps)
{
  const unsigned char BarUp[ 6] = { 255, 240, 127, 224, 63, 192 };
  const unsigned char BarLe[12] = { 128, 192, 224, 224, 224, 224, 224, 224, 224, 224, 192, 128 };
  const unsigned char BarRi[12] = { 32, 96, 224, 224, 224, 224, 224, 224, 224, 224, 96, 32 };
  const unsigned char BarBo[ 6] = { 63, 192, 127, 224, 255, 240 };
  const unsigned char BarMi[ 6] = { 127, 128, 255, 192, 127, 128 };

  char ch[3];
  int i,n,x,y;

  for(x=0;x<8;x++) for(y=0;y<6;y++) Disp_Pixel(42+42*(x>3)+x%4,10+10*(y>2)+y%3,1);

  for(i=0;i<6;i++)
  {
    ch[0] = ((i<2?ptemps->hour:(i<4?ptemps->mins:ptemps->secs))/10)%10;
    ch[1] = (i<2?ptemps->hour:(i<4?ptemps->mins:ptemps->secs))%10;
    n = ch[i&1];

    x = 16*i + 10*(i>>1) + 8;
    y = 2;
    if(n!=1 && n!=4) Disp_Bitmap(BarUp,x,y+0,12,3,1);
    if(n==0 || (n>3 && n!=7)) Disp_Bitmap(BarLe,x,y+2,3,12,1);
    if(n==0 || n==2 || n==6 || n==8) Disp_Bitmap(BarLe,x,y+15,3,12,1);
    if(n!=5 && n!=6) Disp_Bitmap(BarRi,x+9,y+2,3,12,1);
    if(n!=2) Disp_Bitmap(BarRi,x+9,y+15,3,12,1);
    if(n!=1 && n!=4 && n!=7) Disp_Bitmap(BarBo,x,y+26,12,3,1);
    if(n>1 && n!=7) Disp_Bitmap(BarMi,x+1,y+13,10,3,1);
  }
}

void Set(struct Temps *ptemps)
{
  unsigned int key;
  int c=0,x;

  while(1)
  {
    x = 16*c + 10*(c>>1) + 7;
    Disp_Clear();
    DrawTime(ptemps);
    Bdisp_AreaReverseVRAM(x,1,x+13,31);
    locate(9,7); Print((const unsigned char *)"[EXE]");

    while(1)
    {
      GetKey(&key);
      if(key==30002) break;
      if(key==30004) { RTC_SetDateTime(ptemps); return; }

      if((key>='0' && key<='9' && (c==3 || c==5)) ||
         (key>='0' && key<='2' && (c==0))         ||
         (key>='0' && key<='5' && (c==2 || c==4)) ||
         (key>='0' && key<=(ptemps->hour/10==2?'3':'9') && (c==1)))
      {
        x = key-0x30;
        switch(c) {
          case 0: ptemps->hour = ptemps->hour%10 + 10*x; break;
          case 1: ptemps->hour = ptemps->hour-(ptemps->hour)%10 + x; break;
          case 2: ptemps->mins = ptemps->mins%10 + 10*x; break;
          case 3: ptemps->mins = ptemps->mins-(ptemps->mins)%10 + x; break;
          case 4: ptemps->secs = ptemps->secs%10 + 10*x; break;
          case 5: ptemps->secs = ptemps->secs-(ptemps->secs)%10 + x; break; }
        c = (c+1)%6; 
        break;
      }
    }
    if(key==30002) break;
  }
}

int main(int isAppli, unsigned short OptionNum)
{
  unsigned short keycode;
  struct Temps temps;
  int row, col;
  Disp_Init();

  while(1)
  {
    GetKeyW(&col,&row,1,-1,0,&keycode);
    if(row==0x08 && col==0x04) break;
    if(row==0x0A && col==0x07) Set(&temps);

    RTC_GetDateTime(&temps);
    Disp_Clear();

    DrawTime(&temps);
    locate(3,6); Print((const unsigned char *)"  [F1] Set hour");
    locate(3,7); Print((const unsigned char *)"[EXIT] Quit");

    Bdisp_PutDisp_DD();

    // DATA DEBUGGING TOOL CODE : GetKeyW() key detection.
    /* {
    char ch[20];
    int i;
    ch[0] = '0', ch[1] = 'x';
    for(i=0;i<4;i++) ch[5-i] = (keycode&15)+'0', keycode >>= 4;
    ch[6] = 0;
    locate(1,7); Print((unsigned char *)ch);
    for(i=0;i<2;i++) ch[3-i] = (row&15)+'0', row >>= 4;
    ch[4] = 0;
    locate(12,7); Print((unsigned char *)ch);
    for(i=0;i<2;i++) ch[3-i] = (col&15)+'0', col >>= 4;
    ch[4] = 0;
    locate(12,8); Print((unsigned char *)ch); } */
  }

  return 1;
}
